Follow up for “Find Minimum in Rotated Sorted Array”:
What if duplicates are allowed?
Would this affect the run-time complexity? How and why?
Suppose an array sorted in ascending order is rotated at some pivot unknown to you beforehand.
(i.e., 0 1 2 4 5 6 7 might become 4 5 6 7 0 1 2).
Find the minimum element.
The array may contain duplicates.
和上一题leetcode 153. Find Minimum in Rotated Sorted Array的答案一模一样,就是一个简单粗暴的方法,直接寻找转折点就可以了。
代码如下:
/*
* 我的解决办法是最简单粗暴的,直接寻找转折点即可
* */
public class Solution
{
public int findMin(int[] nums)
{
if(nums==null || nums.length<=0 )
return 0;
int min=nums[0];
for(int i=1;i<nums.length;i++)
{
if(nums[i]>=nums[i-1])
continue;
else
{
min = Math.min(min, nums[i]);
break;
}
}
return min;
}
}
下面是C++的做法,和上一道题做法一样,就是寻找转折点
当数组中存在大量的重复数字时,就会破坏二分查找法的机制,我们无法取得O(lgn)的时间复杂度,又将会回到简单粗暴的O(n),比如如下两种情况:
{2, 2, 2, 2, 2, 2, 2, 2, 0, 1, 1, 2} 和 {2, 2, 2, 0, 2, 2, 2, 2, 2, 2, 2, 2}, 我们发现,当第一个数字和最后一个数字,还有中间那个数字全部相等的时候,二分查找法就崩溃了,因为它无法判断到底该去左半边还是右半边。这种情况下,我们将左指针右移一位,略过一个相同数字,这对结果不会产生影响,因为我们只是去掉了一个相同的,然后对剩余的部分继续用二分查找法,在最坏的情况下,比如数组所有元素都相同,时间复杂度会升到O(n),
代码如下:
#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <stack>
#include <string>
#include <climits>
#include <algorithm>
#include <sstream>
#include <functional>
#include <bitset>
#include <numeric>
#include <cmath>
#include <regex>
#include <iomanip>
#include <cstdlib>
#include <ctime>
using namespace std;
class Solution
{
public:
int findMin(vector<int>& a)
{
if (a.size() <= 0)
return 0;
if (a.size() == 1)
return a[0];
int left = 0, right = a.size()-1;
if (a[left] < a[right])
return a[left];
int res = a[0];
while (left != right - 1)
{
int mid = (right - left) / 2 + left;
if (a[left] < a[mid])
{
res = min(res, a[left]);
left = mid;
}
else if (a[left] > a[mid])
{
res = min(res, a[right]);
right = mid;
}
else
left++;
}
res = min(res, min(a[left], a[right]));
return res;
}
};